searchNodes=[{"type":"task","title":"Mix.Tasks.X509.Gen.Selfsigned","doc":"Generates a self-signed certificate for testing. mix x509 . gen . selfsigned mix x509 . gen . selfsigned my - app my - app . local my - app . internal . example . com Creates a private key and a self-signed certificate in PEM format. These files can be referenced in the certfile and keyfile parameters of an :ssl server. WARNING: only use the generated certificate for testing in a closed network environment, such as running a development server on localhost . For production, staging, or testing servers on the public internet, obtain a proper certificate, for example from Let's Encrypt . NOTE: when using Google Chrome, open chrome://flags/#allow-insecure-localhost to enable the use of self-signed certificates on localhost . Arguments The list of hostnames, if none are specified, defaults to: localhost Other (optional) arguments: --output ( -o ): the path and base filename for the certificate and key (default: priv/cert/selfsigned) --name ( -n ): the Common Name value in certificate's subject (default: &quot;Self-signed test certificate&quot;) --force ( -f ): overwrite existing files without prompting for confirmation Requires OTP 20 or later.","ref":"Mix.Tasks.X509.Gen.Selfsigned.html"},{"type":"task","title":"Mix.Tasks.X509.Gen.Suite","doc":"Generates a suite of test certificates. mix x509 . gen . suite mix x509 . gen . suite test . local Please refer to the documentation for X509.Test.Suite for information about the scenarios that may be tested using the generated certificates. WARNING: only use the generated certificates for testing in a closed network environment, such as running a development server on localhost . For production, staging, or testing servers on the public internet, obtain a proper certificate, for example from Let's Encrypt . Arguments This tasks takes a single, optional argument: the domain name to use in the hostnames embedded in the certificates. If no domain name is specified, the default domain from X509.Test.Suite will be used. Other (optional) arguments: '--password' ('-p'): if set, an encrypted, password protected version of each private key will be created --crlserver ( -c ): the base URL for the CRL server to be used for CRL distribution points --output ( -o ): the path where the certificates and keys should be stored (default: priv/cert/suite) --force ( -f ): overwrite existing files without prompting for confirmation Requires OTP 20 or later.","ref":"Mix.Tasks.X509.Gen.Suite.html"},{"type":"task","title":"Mix.Tasks.X509.TestServer","doc":"Runs a server for manual TLS client testing mix x509 . test_server mix x509 . test_server test . local Please refer to the documentation for X509.Test.Suite for information about the scenarios that may be tested using the server. Requires OTP 20 or later.","ref":"Mix.Tasks.X509.TestServer.html"},{"type":"module","title":"X509","doc":"Generic functions for working with X.509 entities.","ref":"X509.html"},{"type":"function","title":"X509.from_pem/2","doc":"Scans the given string for PEM encoded entities. An optional list of data types may be specified to filter the result down to entries of the given types. If an empty list is specified (the default), the result is not filtered.","ref":"X509.html#from_pem/2"},{"type":"module","title":"X509.CRL","doc":"Module for generating and parsing Certificate Revocation Lists (CRLs). The corresponding ASN.1 data type, used in Erlang's :public_key module, is called :CertificateList . Please note that maintaining a CRL typically requires keeping state: the list of revoked certificates, along with their revocation date and expiry date (when they can be removed from the CRL), as well as the CRLs sequence number and the date/time of the next update. This module offers a purely functional interface for generating CRLs based on state kept by the caller. Delta CRLs are not currently supported.","ref":"X509.CRL.html"},{"type":"function","title":"X509.CRL.extension/2","doc":"Looks up the value of a specific extension in a CRL. The desired extension can be specified as an atom or an OID value. Returns nil if the specified extension is not present in the CRL.","ref":"X509.CRL.html#extension/2"},{"type":"function","title":"X509.CRL.extensions/1","doc":"Returns the list of extensions included in a CRL.","ref":"X509.CRL.html#extensions/1"},{"type":"function","title":"X509.CRL.from_der/1","doc":"Parses a CRL in DER (binary) format. Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :malformed - the data could not be decoded as a CRL","ref":"X509.CRL.html#from_der/1"},{"type":"function","title":"X509.CRL.from_der!/1","doc":"Attempts to parse a CRL in DER (binary) format. Raises in case of failure.","ref":"X509.CRL.html#from_der!/1"},{"type":"function","title":"X509.CRL.from_pem/1","doc":"Parses a CRL in PEM format. Processes the first PEM entry of type X509 CRL found in the input. Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :not_found - no PEM entry of type X509 CRL was found :malformed - the entry could not be decoded as a CRL","ref":"X509.CRL.html#from_pem/1"},{"type":"function","title":"X509.CRL.from_pem!/1","doc":"Attempts to parse a CRL in PEM format. Raises in case of failure. Processes the first PEM entry of type X509 CRL found in the input.","ref":"X509.CRL.html#from_pem!/1"},{"type":"function","title":"X509.CRL.issuer/1","doc":"Returns the Issuer field of the CRL.","ref":"X509.CRL.html#issuer/1"},{"type":"function","title":"X509.CRL.list/1","doc":"Returns the list of CRL entries included in a CRL.","ref":"X509.CRL.html#list/1"},{"type":"function","title":"X509.CRL.new/4","doc":"Returns a new :CertificateList record for the specified CRL entries. The first argument is a, possibly empty, list of CRL entries. Use X509.CRL.Entry.new/3 to create a CRL entry for a given certificate. The second and third argument are the issuing certificate and the associated private key. The certificate must include the :cRLSign key usage. Options: :hash - the hashing algorithm to use when signing the CRL (default: :sha256 ) :this_update - a DateTime struct specifying the timestamp of the CRL update (default: the current time) :next_update - a DateTime struct specifying the timestamp of next scheduled CRL update (default: see :next_update_in_days ) :next_update_in_days - if no :next_update timestamp is specified, this parameter defines the number of days in the future the next CRL update is expected (default: 30) :extensions - a keyword list of extension names and values; by default the authority_key_identifier extension will be included, with a value derived from the issuer's subject_key_identifier (if present); to disable this extension, specify authority_key_identifier: false ; other extension values will be included in the CRL as-is","ref":"X509.CRL.html#new/4"},{"type":"function","title":"X509.CRL.next_update/1","doc":"Returns the date and time when the next CRL update is expected.","ref":"X509.CRL.html#next_update/1"},{"type":"function","title":"X509.CRL.this_update/1","doc":"Returns the date and time when the CRL was issued.","ref":"X509.CRL.html#this_update/1"},{"type":"function","title":"X509.CRL.to_der/1","doc":"Converts a CRL to DER (binary) format.","ref":"X509.CRL.html#to_der/1"},{"type":"function","title":"X509.CRL.to_pem/1","doc":"Converts a CRL to PEM format.","ref":"X509.CRL.html#to_pem/1"},{"type":"function","title":"X509.CRL.valid?/2","doc":"Verifies whether a CRL matches the given issuer certificate and has a valid signature.","ref":"X509.CRL.html#valid?/2"},{"type":"opaque","title":"X509.CRL.t/0","doc":":CertificateList record, as used in Erlang's :public_key module","ref":"X509.CRL.html#t:t/0"},{"type":"module","title":"X509.CRL.Entry","doc":"CRL entries identify revoked certificates and contain metadata about the revocation.","ref":"X509.CRL.Entry.html"},{"type":"function","title":"X509.CRL.Entry.extension/2","doc":"Looks up a specific extension in a CRL entry. The desired extension can be specified as an atom or an OID value. Returns nil if the specified extension is not present in the CRL entry.","ref":"X509.CRL.Entry.html#extension/2"},{"type":"function","title":"X509.CRL.Entry.extensions/1","doc":"Returns the list of extensions in a CRL entry.","ref":"X509.CRL.Entry.html#extensions/1"},{"type":"function","title":"X509.CRL.Entry.new/3","doc":"Returns a new CRL entry for the given certificate or serial number. The revocation date must be specified, and additional metadata may be specified as one or more X509.CRL.Extension entries.","ref":"X509.CRL.Entry.html#new/3"},{"type":"function","title":"X509.CRL.Entry.revocation_date/1","doc":"Returns the certificate recocation date for a CRL entry.","ref":"X509.CRL.Entry.html#revocation_date/1"},{"type":"function","title":"X509.CRL.Entry.serial/1","doc":"Returns the certificate serial number for a CRL entry.","ref":"X509.CRL.Entry.html#serial/1"},{"type":"opaque","title":"X509.CRL.Entry.t/0","doc":":TBSCertList_revokedCertificates_SEQOF record, as used in Erlang's :public_key module","ref":"X509.CRL.Entry.html#t:t/0"},{"type":"module","title":"X509.CRL.Extension","doc":"Convenience functions for creating :Extension records for use in CRLs or CRL entries. Some extensions defined in X509.Certificate.Extension may also be used in CRLs (e.g. authority_key_identifier ). Please use the functions in that module to create such extension records.","ref":"X509.CRL.Extension.html"},{"type":"function","title":"X509.CRL.Extension.crl_number/1","doc":"The CRL number conveys a monotonically increasing sequence number for a given CRL scope and CRL issuer. This extension allows users to easily determine when a particular CRL supersedes another CRL. This extension is marked as non-critical. Example: iex&gt; X509.CRL.Extension . crl_number ( 12 ) { :Extension , { 2 , 5 , 29 , 20 } , false , &lt;&lt; 2 , 1 , 12 &gt;&gt; }","ref":"X509.CRL.Extension.html#crl_number/1"},{"type":"function","title":"X509.CRL.Extension.find/2","doc":"Looks up the value of a specific extension in a list. The desired extension can be specified as an atom or an OID value. Returns nil if the specified extension is not present in the certificate.","ref":"X509.CRL.Extension.html#find/2"},{"type":"function","title":"X509.CRL.Extension.reason_code/1","doc":"The reason code identifies the reason for the certificate revocation. CRL issuers are strongly encouraged to include meaningful reason codes in CRL entries. The value :removeFromCRL is reserved for use in delta CRLs. This extension is marked as non-critical. Example: iex&gt; X509.CRL.Extension . reason_code ( :keyCompromise ) { :Extension , { 2 , 5 , 29 , 21 } , false , &lt;&lt; 10 , 1 , 1 &gt;&gt; }","ref":"X509.CRL.Extension.html#reason_code/1"},{"type":"type","title":"X509.CRL.Extension.extension_id/0","doc":"","ref":"X509.CRL.Extension.html#t:extension_id/0"},{"type":"type","title":"X509.CRL.Extension.reason_code_value/0","doc":"Supported values in the reason code extension","ref":"X509.CRL.Extension.html#t:reason_code_value/0"},{"type":"opaque","title":"X509.CRL.Extension.t/0","doc":":Extension record, as used in Erlang's :public_key module","ref":"X509.CRL.Extension.html#t:t/0"},{"type":"module","title":"X509.CSR","doc":"Implements PKCS#10 Certificate Signing Requests (CSRs), formally known by their ASN.1 type CertificationRequest.","ref":"X509.CSR.html"},{"type":"function","title":"X509.CSR.extension_request/1","doc":"Returns the certificate extensions from the extensionRequest attribute.","ref":"X509.CSR.html#extension_request/1"},{"type":"function","title":"X509.CSR.from_der/1","doc":"Parses a CSR in DER (binary) format. Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :malformed - the data could not be decoded as a CSR","ref":"X509.CSR.html#from_der/1"},{"type":"function","title":"X509.CSR.from_der!/1","doc":"Attempts to parse a CSR in DER (binary) format. Raises in case of failure.","ref":"X509.CSR.html#from_der!/1"},{"type":"function","title":"X509.CSR.from_pem/1","doc":"Parses a CSR in PEM format. Processes the first PEM entry of type CERTIFICATE REQUEST found in the input. Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :not_found - no PEM entry of type CERTIFICATE REQUEST was found :malformed - the entry could not be decoded as a CSR","ref":"X509.CSR.html#from_pem/1"},{"type":"function","title":"X509.CSR.from_pem!/1","doc":"Attempts to parse a CSR in PEM format. Raises in case of failure. Processes the first PEM entry of type CERTIFICATE REQUEST found in the input.","ref":"X509.CSR.html#from_pem!/1"},{"type":"function","title":"X509.CSR.new/3","doc":"Returns a :CertificationRequest record for the given key pair and subject. Supports RSA and EC private keys. The public key is extracted from the private key (unless overridden; see Options below) and encoded, together with the subject, in the CSR. The CSR is then signed with the private key, using a configurable hash algorithm. The private key may be specified as an 'engine reference'. Please refer to documentation for Erlang/OTP's :crypto application for further information about engines. The default hash algorithm is :sha256 . An alternative algorithm can be specified using the :hash option. Possible values include :sha224 , :sha256 , :sha384 , :sha512 . Older hash algorithms, supported for compatibility with older software only, include :md5 (RSA only) and :sha . The use of these algorithms is discouraged. Options: :hash - the hashing algorithm to use when signing the CSR (default: :sha256 ) :extension_request - a list of certificate extensions to be included as an extensionRequest attribute (see X509.Certificate.Extension ) :public_key - the public key to include in the CSR; by default the public key is derived from the private key, but if that does not work (for certain private keys stored in an 'engine') it can be useful to override the value using this option (default: from private key) Example: iex&gt; priv = X509.PrivateKey . new_ec ( :secp256r1 ) iex&gt; csr = X509.CSR . new ( priv , &quot;/C=US/ST=NT/L=Springfield/O=ACME Inc.&quot; , ...&gt; extension_request : [ ...&gt; X509.Certificate.Extension . subject_alt_name ( [ &quot;www.example.net&quot; ] ) ...&gt; ] ...&gt; ) iex&gt; X509.CSR . valid? ( csr ) true","ref":"X509.CSR.html#new/3"},{"type":"function","title":"X509.CSR.public_key/1","doc":"Extracts the public key from the CSR.","ref":"X509.CSR.html#public_key/1"},{"type":"function","title":"X509.CSR.subject/1","doc":"Returns the Subject field of the CSR.","ref":"X509.CSR.html#subject/1"},{"type":"function","title":"X509.CSR.to_der/1","doc":"Converts a CSR to DER (binary) format.","ref":"X509.CSR.html#to_der/1"},{"type":"function","title":"X509.CSR.to_pem/1","doc":"Converts a CSR to PEM format.","ref":"X509.CSR.html#to_pem/1"},{"type":"function","title":"X509.CSR.valid?/1","doc":"Verifies whether a CSR has a valid signature.","ref":"X509.CSR.html#valid?/1"},{"type":"opaque","title":"X509.CSR.t/0","doc":":CertificationRequest record , as used in Erlang's :public_key module","ref":"X509.CSR.html#t:t/0"},{"type":"module","title":"X509.Certificate","doc":"Module for issuing and working with X.509 certificates. The primary data type for this module is the :OTPCertificate record, but the PEM and DER import and export functions also support the :Certificate record type. The former is more convenient to work with, since nested ASN.1 elements are further decoded, and some named elements are identified by atoms rather than OID values.","ref":"X509.Certificate.html"},{"type":"function","title":"X509.Certificate.extension/2","doc":"Looks up the value of a specific extension in a certificate. The desired extension can be specified as an atom or an OID value. Returns nil if the specified extension is not present in the certificate.","ref":"X509.Certificate.html#extension/2"},{"type":"function","title":"X509.Certificate.extensions/1","doc":"Returns the list of extensions included in a certificate.","ref":"X509.Certificate.html#extensions/1"},{"type":"function","title":"X509.Certificate.from_der/2","doc":"Attempts to parse a certificate in DER (binary) format. The optional second parameter specifies the record type to be returned: :OTPCertificate (default) or :Certificate . Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :malformed - the data could not be decoded as a certificate","ref":"X509.Certificate.html#from_der/2"},{"type":"function","title":"X509.Certificate.from_der!/2","doc":"Attempts to parse a certificate in DER (binary) format. Raises in case of failure. The optional second parameter specifies the record type to be returned: :OTPCertificate (default) or :Certificate .","ref":"X509.Certificate.html#from_der!/2"},{"type":"function","title":"X509.Certificate.from_pem/2","doc":"Attempts to parse a certificate in PEM format. Processes the first PEM entry of type CERTIFICATE found in the input. The optional second parameter specifies the record type to be returned: :OTPCertificate (default) or :Certificate . Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :not_found - no PEM entry of type CERTIFICATE was found :malformed - the entry could not be decoded as a certificate","ref":"X509.Certificate.html#from_pem/2"},{"type":"function","title":"X509.Certificate.from_pem!/2","doc":"Attempts to parse a certificate in PEM format. Raises in case of failure. Processes the first PEM entry of type CERTIFICATE found in the input. The optional second parameter specifies the record type to be returned: :OTPCertificate (default) or :Certificate .","ref":"X509.Certificate.html#from_pem!/2"},{"type":"function","title":"X509.Certificate.issuer/1","doc":"Returns the Issuer field of a certificate.","ref":"X509.Certificate.html#issuer/1"},{"type":"function","title":"X509.Certificate.issuer/2","doc":"Returns attribute values of the Issuer field of a certificate. See also X509.RDNSequence.get_attr/2 .","ref":"X509.Certificate.html#issuer/2"},{"type":"function","title":"X509.Certificate.new/5","doc":"Issues a new certificate. The public key can be an RSA key or an EC key (which results in an ECDSA certificate). The Subject can be specified as a string, to be parsed by X509.RDNSequence.new/1 , or a custom RDN sequence tuple. The next parameters are the issuing certificate and the associated private key (RSA or EC). The Issuer field of the new certificate is taken from the issuing certificate's Subject. Options: :template - an X509.Certificate.Template struct, or an atom selecting a built-in template (default: :server ) :hash - the hashing algorithm to use when signing the certificate (default: from template) :serial - the certificate's serial number (an integer &gt;0), {:random, n} to generate an n-byte random value, or nil . (default: from template) :validity - an integer specifying the certificate's validity in days, or an X509.Certificate.Validity record defining the 'not before' and 'not after' timestamps (default: from template) :extensions - a keyword list of extension names and values, to be merged with the extensions defined in the template; refer to the X509.Certificate.Template documentation for details","ref":"X509.Certificate.html#new/5"},{"type":"function","title":"X509.Certificate.public_key/1","doc":"Returns the public key embedded in a certificate.","ref":"X509.Certificate.html#public_key/1"},{"type":"function","title":"X509.Certificate.self_signed/3","doc":"Generates a new self-signed certificate. The private key is used both to sign and to extract the public key to be embedded in the certificate. It can be an RSA key or an EC key (which results in an ECDSA certificate). The Subject can be specified as a string, to be parsed by X509.RDNSequence.new/1 , or a custom RDN sequence tuple. The same value is used in the Issuer field as well. Options: :template - an X509.Certificate.Template struct, or an atom selecting a built-in template (default: :server ) :hash - the hashing algorithm to use when signing the certificate (default: from template) :serial - the certificate's serial number (default: from template, where it will typically be set to nil , resulting in a random value) :validity - an integer specifying the certificate's validity in days, or an X509.Certificate.Validity record defining the 'not before' and 'not after' timestamps (default: from template) :extensions - a keyword list of extension names and values, to be merged with the extensions defined in the template; refer to the X509.Certificate.Template documentation for details","ref":"X509.Certificate.html#self_signed/3"},{"type":"function","title":"X509.Certificate.serial/1","doc":"Returns the serial number of the certificate.","ref":"X509.Certificate.html#serial/1"},{"type":"function","title":"X509.Certificate.subject/1","doc":"Returns the Subject field of a certificate.","ref":"X509.Certificate.html#subject/1"},{"type":"function","title":"X509.Certificate.subject/2","doc":"Returns attribute values of the Subject field of a certificate. See also X509.RDNSequence.get_attr/2 .","ref":"X509.Certificate.html#subject/2"},{"type":"function","title":"X509.Certificate.to_der/1","doc":"Converts a certificate to DER (binary) format.","ref":"X509.Certificate.html#to_der/1"},{"type":"function","title":"X509.Certificate.to_pem/1","doc":"Converts a certificate to PEM format.","ref":"X509.Certificate.html#to_pem/1"},{"type":"function","title":"X509.Certificate.validity/1","doc":"Returns the Validity of a certificate.","ref":"X509.Certificate.html#validity/1"},{"type":"function","title":"X509.Certificate.version/1","doc":"Returns the Version field of a certificate. Returns the X.509 certificate version as an atom, e.g. :v3 .","ref":"X509.Certificate.html#version/1"},{"type":"type","title":"X509.Certificate.t/0","doc":":OTPCertificate record , as used in Erlang's :public_key module","ref":"X509.Certificate.html#t:t/0"},{"type":"module","title":"X509.Certificate.Extension","doc":"Convenience functions for creating :Extension records for use in certificates.","ref":"X509.Certificate.Extension.html"},{"type":"function","title":"X509.Certificate.Extension.authority_info_access/1","doc":"The authority information access extension indicates how to access information and services for the issuer of the certificate in which the extension appears. Information and services may include on-line validation services and CA policy data. This extension may be included in end entity or CA certificates. This extension is marked as non-critical. Example: iex&gt; X509.Certificate.Extension . authority_info_access ( ...&gt; ocsp : &quot;http://ocsp.example.net/&quot; ...&gt; ) { :Extension , { 1 , 3 , 6 , 1 , 5 , 5 , 7 , 1 , 1 } , false , [ { :AccessDescription , { 1 , 3 , 6 , 1 , 5 , 5 , 7 , 48 , 1 } , { :uniformResourceIdentifier , &quot;http://ocsp.example.net/&quot; } } ] }","ref":"X509.Certificate.Extension.html#authority_info_access/1"},{"type":"function","title":"X509.Certificate.Extension.authority_key_identifier/1","doc":"The authority key identifier extension provides a means of identifying the public key corresponding to the private key used to sign a certificate. The value should be a public key record. It is possible to pass a pre-calculated SHA-1 value, though it is preferred to let the function calculate the correct value over the original public key. This extension is marked as non-critical. Example: iex&gt; X509.Certificate.Extension . authority_key_identifier ( { :RSAPublicKey , 55 , 3 } ) { :Extension , { 2 , 5 , 29 , 35 } , false , { :AuthorityKeyIdentifier , &lt;&lt; 187 , 230 , 143 , 92 , 27 , 37 , 166 , 93 , 176 , 137 , 154 , 111 , 62 , 152 , 215 , 114 , 3 , 214 , 71 , 170 &gt;&gt; , :asn1_NOVALUE , :asn1_NOVALUE } }","ref":"X509.Certificate.Extension.html#authority_key_identifier/1"},{"type":"function","title":"X509.Certificate.Extension.basic_constraints/2","doc":"The basic constraints extension identifies whether the subject of the certificate is a CA and the maximum depth of valid certification paths that include this certificate. This extension is always marked as critical for CA certificates, and non-critical when CA is set to false. Examples: iex&gt; X509.Certificate.Extension . basic_constraints ( false ) { :Extension , { 2 , 5 , 29 , 19 } , false , { :BasicConstraints , false , :asn1_NOVALUE } } iex&gt; X509.Certificate.Extension . basic_constraints ( true ) { :Extension , { 2 , 5 , 29 , 19 } , true , { :BasicConstraints , true , :asn1_NOVALUE } } iex&gt; X509.Certificate.Extension . basic_constraints ( true , 0 ) { :Extension , { 2 , 5 , 29 , 19 } , true , { :BasicConstraints , true , 0 } }","ref":"X509.Certificate.Extension.html#basic_constraints/2"},{"type":"function","title":"X509.Certificate.Extension.crl_distribution_points/1","doc":"The CRL distribution points extension identifies how CRL information is obtained. The list of distribution points must be specified as a list of strings containing HTTP, FTP and/or LDAP URIs. Other types of distribution points are defined in RFC 5280, but are not supported by this function at this time. This extension is marked as non-critical. Example: iex&gt; X509.Certificate.Extension . crl_distribution_points ( [ &quot;http://crl.example.org/root.crl&quot; ] ) { :Extension , { 2 , 5 , 29 , 31 } , false , [ { :DistributionPoint , { :fullName , [ uniformResourceIdentifier : ~c&quot;http://crl.example.org/root.crl&quot; ] } , :asn1_NOVALUE , :asn1_NOVALUE } ] }","ref":"X509.Certificate.Extension.html#crl_distribution_points/1"},{"type":"function","title":"X509.Certificate.Extension.ext_key_usage/1","doc":"This extension indicates one or more purposes for which the certified public key may be used, in addition to or in place of the basic purposes indicated in the key usage extension. In general, this extension will appear only in end entity certificates. Each of the values in the list must be an OID, either in raw tuple format or as an atom representing a well-known OID. Typical examples include: :serverAuth - TLS WWW server authentication :clientAuth - TLS WWW client authentication :codeSigning - Signing of downloadable executable code :emailProtection - Email protection :timeStamping - Binding the hash of an object to a time :ocspSigning - Signing OCSP responses This extension is marked as non-critical. Example: iex&gt; X509.Certificate.Extension . ext_key_usage ( [ :serverAuth , :clientAuth ] ) { :Extension , { 2 , 5 , 29 , 37 } , false , [ { 1 , 3 , 6 , 1 , 5 , 5 , 7 , 3 , 1 } , { 1 , 3 , 6 , 1 , 5 , 5 , 7 , 3 , 2 } ] }","ref":"X509.Certificate.Extension.html#ext_key_usage/1"},{"type":"function","title":"X509.Certificate.Extension.find/2","doc":"Looks up the value of a specific extension in a list. The desired extension can be specified as an atom or an OID value. Returns nil if the specified extension is not present in the certificate.","ref":"X509.Certificate.Extension.html#find/2"},{"type":"function","title":"X509.Certificate.Extension.key_usage/1","doc":"The key usage extension defines the purpose (e.g., encipherment, signature, certificate signing) of the key contained in the certificate. Each of the key usage values must be one of the atoms recognized by Erlang's :public_key module, though this is not verified by this function. This extension is always marked as critical. Example: iex&gt; X509.Certificate.Extension . key_usage ( [ :digitalSignature , :keyEncipherment ] ) { :Extension , { 2 , 5 , 29 , 15 } , true , [ :digitalSignature , :keyEncipherment ] }","ref":"X509.Certificate.Extension.html#key_usage/1"},{"type":"function","title":"X509.Certificate.Extension.ocsp_nocheck/0","doc":"The OCSP Nocheck extension indicates that the OCSP client can trust this OCSP responder certificate for the lifetime of the certificate, and no revocation checks are needed. This extension has no value, it acts as a flag simply by being present in a certificate's extension list. This extension is marked as non-critical. Example: iex&gt; X509.Certificate.Extension . ocsp_nocheck ( ) { :Extension , { 1 , 3 , 6 , 1 , 5 , 5 , 7 , 48 , 1 , 5 } , false , &lt;&lt; 5 , 0 &gt;&gt; }","ref":"X509.Certificate.Extension.html#ocsp_nocheck/0"},{"type":"function","title":"X509.Certificate.Extension.subject_alt_name/1","doc":"The subject alternative name extension allows identities to be bound to the subject of the certificate. These identities may be included in addition to or in place of the identity in the subject field of the certificate. Defined options include an Internet electronic mail address, a DNS name, an IP address, and a Uniform Resource Identifier (URI). Typically the subject alternative name extension is used to define the DNS domains or hostnames for which a certificate is valid, so this function maps string values to DNSName entries. Values of other types can be passed in a type/value tuples as supported by Erlang's :public_key module, if required. Note that Erlang will typically require the value to be a character list. This extension is marked as non-critical. Example: iex&gt; X509.Certificate.Extension . subject_alt_name ( [ &quot;www.example.com&quot; , &quot;example.com&quot; ] ) { :Extension , { 2 , 5 , 29 , 17 } , false , [ dNSName : ~c&quot;www.example.com&quot; , dNSName : ~c&quot;example.com&quot; ] } iex&gt; X509.Certificate.Extension . subject_alt_name ( emailAddress : ~c&quot;user@example.com&quot; ) { :Extension , { 2 , 5 , 29 , 17 } , false , [ emailAddress : ~c&quot;user@example.com&quot; ] }","ref":"X509.Certificate.Extension.html#subject_alt_name/1"},{"type":"function","title":"X509.Certificate.Extension.subject_key_identifier/1","doc":"The subject key identifier extension provides a means of identifying certificates that contain a particular public key. The value should be a public key record or a pre-calculated binary SHA-1 value. This extension is marked as non-critical. Example: iex&gt; X509.Certificate.Extension . subject_key_identifier ( { :RSAPublicKey , 55 , 3 } ) { :Extension , { 2 , 5 , 29 , 14 } , false , &lt;&lt; 187 , 230 , 143 , 92 , 27 , 37 , 166 , 93 , 176 , 137 , 154 , 111 , 62 , 152 , 215 , 114 , 3 , 214 , 71 , 170 &gt;&gt; }","ref":"X509.Certificate.Extension.html#subject_key_identifier/1"},{"type":"type","title":"X509.Certificate.Extension.aia_access_method/0","doc":"","ref":"X509.Certificate.Extension.html#t:aia_access_method/0"},{"type":"type","title":"X509.Certificate.Extension.extension_id/0","doc":"","ref":"X509.Certificate.Extension.html#t:extension_id/0"},{"type":"type","title":"X509.Certificate.Extension.key_usage_value/0","doc":"Supported values in the key usage extension","ref":"X509.Certificate.Extension.html#t:key_usage_value/0"},{"type":"type","title":"X509.Certificate.Extension.san_value/0","doc":"An entry for use in the subject alternate name extension. Strings are mapped to DNSName values, tuples must contain values supported by Erlang's :public_key module","ref":"X509.Certificate.Extension.html#t:san_value/0"},{"type":"type","title":"X509.Certificate.Extension.t/0","doc":":Extension record, as used in Erlang's :public_key module","ref":"X509.Certificate.Extension.html#t:t/0"},{"type":"module","title":"X509.Certificate.Template","doc":"Certificate templates.","ref":"X509.Certificate.Template.html"},{"type":"function","title":"X509.Certificate.Template.new/2","doc":"Returns a template, optionally customized with user-provided validity, hash and extensions options. The base template can be selected from a list of built-in named templates, or as a custom template. The following named templates are supported: :root_ca - intended for a self-signed root CA. The default path length constraint is set to 1, meaning the root CA can be used to issue intermediate CAs, and those CAs can only sign end certificates. The value can be overridden by passing a custom value for the :basic_constraints extension. The default validity is 25 years. :ca - intended for intermediate CA certificates. The default path length constraint is set to 0, meaning the CA can only sign end certificates. The value can be overridden by passing a custom value for the :basic_constraints extension (assuming the issuing CA allows it). The Extended Key Usage extension is set to TLS server &amp; client. Many (but not all) TLS implementations will interpret this as a constraint on the type of certificates the CA is allowed to issue. This constraint can be removed by setting :ext_key_usage to false , or by overriding the value to set the desired constraints. The default validity is 10 years. :server - intended for end-certificates. The Extended Key Usage extension is set to TLS server &amp; client. For other types of end-certificates, set the :ext_key_usage extension to the desired value. It may be necessary to update the :key_usage value as well. The default validity is 1 year, plus a 30 day grace period. :ocsp_responder - designated responder to sign OCSP responses on behalf of the issuing CA. The Extended Key Usage extension is set to allow OCSP signing only. Must be issued directly from the CA certificate for which OCSP responses will be signed. The OCSP Nocheck extension is included, to disable revocation checks for the OCSP responder certificate. To exclude this extension override it with a value of false (e.g. extensions: [ocsp_nocheck: false] ) The default validity is just 30 days, due to the fact that revocation is not possible when OCSP Nocheck is set. All of the above templates generate a random 8 byte (64 bit) serial number, which can be overridden through the :serial option (see below). The extensions attribute of a template is a keyword list of extension name/value pairs, where the value should typically be an X509.Certificate.Extension record. The subject_key_identifier and authority_key_identifier extensions may simply be set to true : the actual values will be calculated during the certificate signing process. Options: :hash - the hash algorithm to use when signing the certificate :serial - the serial number of the certificate (an integer &gt;0) or {:random, n} to generate an n-byte random serial number :validity - override the validity period; can be specified as the number of days (integer) or a X509.Certificate.Validity value :extensions - a keyword list of extensions to be merged into the template's defaults; set an extension value to false to exclude that extension from the certificate Examples: iex&gt; X509.Certificate.Template . new ( :root_ca , ...&gt; hash : :sha512 , serial : 1 , ...&gt; extensions : [ authority_key_identifier : false ] ...&gt; ) % X509.Certificate.Template { extensions : [ basic_constraints : { :Extension , { 2 , 5 , 29 , 19 } , true , { :BasicConstraints , true , 1 } } , key_usage : { :Extension , { 2 , 5 , 29 , 15 } , true , [ :digitalSignature , :keyCertSign , :cRLSign ] } , subject_key_identifier : true , authority_key_identifier : false ] , hash : :sha512 , serial : 1 , validity : 9131 } iex&gt; X509.Certificate.Template . new ( :server , extensions : [ ...&gt; ext_key_usage : X509.Certificate.Extension . ext_key_usage ( [ :codeSigning ] ) ...&gt; ] ) % X509.Certificate.Template { extensions : [ basic_constraints : { :Extension , { 2 , 5 , 29 , 19 } , false , { :BasicConstraints , false , :asn1_NOVALUE } } , key_usage : { :Extension , { 2 , 5 , 29 , 15 } , true , [ :digitalSignature , :keyEncipherment ] } , subject_key_identifier : true , authority_key_identifier : true , ext_key_usage : { :Extension , { 2 , 5 , 29 , 37 } , false , [ { 1 , 3 , 6 , 1 , 5 , 5 , 7 , 3 , 3 } ] } ] , hash : :sha256 , serial : { :random , 8 } , validity : 395 }","ref":"X509.Certificate.Template.html#new/2"},{"type":"type","title":"X509.Certificate.Template.named_template/0","doc":"","ref":"X509.Certificate.Template.html#t:named_template/0"},{"type":"type","title":"X509.Certificate.Template.t/0","doc":"","ref":"X509.Certificate.Template.html#t:t/0"},{"type":"module","title":"X509.Certificate.Validity","doc":"Convenience functions for creating :Validity records for use in certificates. The :Validity record represents the X.509 Validity type, defining the validity of a certificate in terms of notBefore and notAfter timestamps.","ref":"X509.Certificate.Validity.html"},{"type":"function","title":"X509.Certificate.Validity.days_from_now/2","doc":"Creates a new :Validity record with an notAfter value a given number of days in the future. The notBefore value can be backdated (by default 300 seconds) to avoid newly issued certificates from being rejected by peers due to poorly synchronized clocks. For CA certificates, consider using new/2 instead, with a not_before value that does not reveal the exact time when the key pair was generated. This minimizes information leakage about the state of the RNG.","ref":"X509.Certificate.Validity.html#days_from_now/2"},{"type":"function","title":"X509.Certificate.Validity.new/2","doc":"Creates a new :Validity record with the given start and end timestamps in DateTime format. Examples: iex&gt; { :ok , not_before , 0 } = DateTime . from_iso8601 ( &quot;2018-01-01T00:00:00Z&quot; ) iex&gt; { :ok , not_after , 0 } = DateTime . from_iso8601 ( &quot;2018-12-31T23:59:59Z&quot; ) iex&gt; X509.Certificate.Validity . new ( not_before , not_after ) { :Validity , { :utcTime , ~c&quot;180101000000Z&quot; } , { :utcTime , ~c&quot;181231235959Z&quot; } } iex&gt; { :ok , not_before , 0 } = DateTime . from_iso8601 ( &quot;2051-01-01T00:00:00Z&quot; ) iex&gt; { :ok , not_after , 0 } = DateTime . from_iso8601 ( &quot;2051-12-31T23:59:59Z&quot; ) iex&gt; X509.Certificate.Validity . new ( not_before , not_after ) { :Validity , { :generalTime , ~c&quot;20510101000000Z&quot; } , { :generalTime , ~c&quot;20511231235959Z&quot; } }","ref":"X509.Certificate.Validity.html#new/2"},{"type":"type","title":"X509.Certificate.Validity.t/0","doc":":Validity record, as used in Erlang's :public_key module","ref":"X509.Certificate.Validity.html#t:t/0"},{"type":"type","title":"X509.Certificate.Validity.time/0","doc":"X.509 Time type (UTCTime or GeneralizedTime)","ref":"X509.Certificate.Validity.html#t:time/0"},{"type":"module","title":"X509.PrivateKey","doc":"Functions for generating, reading and writing RSA and EC private keys. Example use with :public_key Encryption and decryption: iex&gt; private_key = X509.PrivateKey . new_rsa ( 2048 ) iex&gt; public_key = X509.PublicKey . derive ( private_key ) iex&gt; plaintext = &quot;Hello, world!&quot; iex&gt; ciphertext = :public_key . encrypt_public ( plaintext , public_key ) iex&gt; :public_key . decrypt_private ( ciphertext , private_key ) &quot;Hello, world!&quot; Signing and signature verification: iex&gt; private_key = X509.PrivateKey . new_ec ( :secp256r1 ) iex&gt; public_key = X509.PublicKey . derive ( private_key ) iex&gt; message = &quot;Hello, world!&quot; iex&gt; signature = :public_key . sign ( message , :sha256 , private_key ) iex&gt; :public_key . verify ( message , :sha256 , signature , public_key ) true Note that in practice it is not a good idea to directly encrypt a message with asymmetrical cryptography. The examples above are deliberate over-simpliciations intended to highlight the :public_key API calls.","ref":"X509.PrivateKey.html"},{"type":"function","title":"X509.PrivateKey.from_der/1","doc":"Attempts to parse a private key in DER (binary) format. Unwraps the PKCS#8 PrivateKeyInfo container, if present. Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :malformed - the data could not be decoded as a private key","ref":"X509.PrivateKey.html#from_der/1"},{"type":"function","title":"X509.PrivateKey.from_der!/1","doc":"Attempts to parse a private key in DER (binary) format. Raises in case of failure. Unwraps the PKCS#8 PrivateKeyInfo container, if present.","ref":"X509.PrivateKey.html#from_der!/1"},{"type":"function","title":"X509.PrivateKey.from_pem/2","doc":"Attempts to parse a private key in PEM format. Processes the first PEM entry of type PRIVATE KEY, RSA PRIVATE KEY or EC PRIVATE KEY found in the input. Unwraps the PKCS#8 PrivateKeyInfo container, if present. Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :not_found - no PEM entry of a supported PRIVATE KEY type was found :malformed - the entry could not be decoded as a private key Options: :password - the password used to decrypt an encrypted private key; may be specified as a string or a charlist","ref":"X509.PrivateKey.html#from_pem/2"},{"type":"function","title":"X509.PrivateKey.from_pem!/2","doc":"Attempts to parse a private key in PEM format. Raises in case of failure. Processes the first PEM entry of type PRIVATE KEY, RSA PRIVATE KEY or EC PRIVATE KEY found in the input. Unwraps the PKCS#8 PrivateKeyInfo container, if present. Options: :password - the password used to decrypt an encrypted private key; may be specified as a string or a charlist","ref":"X509.PrivateKey.html#from_pem!/2"},{"type":"function","title":"X509.PrivateKey.new_ec/1","doc":"Generates a new EC private key. To derive the public key, use X509.PublicKey.derive/1 . The first parameter must specify a named curve. The curve can be specified as an atom or an OID tuple. Note that this function uses Erlang/OTP's :public_key application, which does not support all curve names returned by the :crypto.ec_curves/0 function. In particular, the NIST Prime curves must be selected by their SECG id, e.g. NIST P-256 is :secp256r1 rather than :prime256v1 . Please refer to RFC4492 appendix A for a mapping table.","ref":"X509.PrivateKey.html#new_ec/1"},{"type":"function","title":"X509.PrivateKey.new_rsa/2","doc":"Generates a new RSA private key. To derive the public key, use X509.PublicKey.derive/1 . The key length in bits must be specified as an integer (minimum 256 bits). The default exponent of 65537 can be overridden using the :exponent option. Warning: the custom exponent value is not checked for safety!","ref":"X509.PrivateKey.html#new_rsa/2"},{"type":"function","title":"X509.PrivateKey.to_der/2","doc":"Converts a private key to DER (binary) format. Options: :wrap - Wrap the private key in a PKCS#8 PrivateKeyInfo container (default: false )","ref":"X509.PrivateKey.html#to_der/2"},{"type":"function","title":"X509.PrivateKey.to_pem/2","doc":"Converts a private key to PEM format. Options: :wrap - Wrap the private key in a PKCS#8 PrivateKeyInfo container (default: false ) :password - If a password is specified, the private key is encrypted using 3DES; to password will be required to decode the PEM entry","ref":"X509.PrivateKey.html#to_pem/2"},{"type":"function","title":"X509.PrivateKey.unwrap/1","doc":"Extracts a private key from a PKCS#8 PrivateKeyInfo container.","ref":"X509.PrivateKey.html#unwrap/1"},{"type":"function","title":"X509.PrivateKey.wrap/1","doc":"Wraps a private key in a PKCS#8 PrivateKeyInfo container.","ref":"X509.PrivateKey.html#wrap/1"},{"type":"type","title":"X509.PrivateKey.t/0","doc":"RSA or EC private key","ref":"X509.PrivateKey.html#t:t/0"},{"type":"module","title":"X509.PublicKey","doc":"Functions for deriving, reading and writing RSA and EC public keys.","ref":"X509.PublicKey.html"},{"type":"function","title":"X509.PublicKey.derive/1","doc":"Derives the public key from the given RSA or EC private key. The private key may be specified as an 'engine reference'. Please refer to documentation for Erlang/OTP's :crypto application for further information about engines. However, please note that :crypto may not support this API for all key types.","ref":"X509.PublicKey.html#derive/1"},{"type":"function","title":"X509.PublicKey.from_der/1","doc":"Attempts to parse a public key in DER (binary) format. Unwraps a SubjectPublicKeyInfo style container, if present. Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :malformed - the data could not be decoded as a public key","ref":"X509.PublicKey.html#from_der/1"},{"type":"function","title":"X509.PublicKey.from_der!/1","doc":"Attempts to parse a public key in DER (binary) format. Raises in case of failure. Unwraps a SubjectPublicKeyInfo style container, if present.","ref":"X509.PublicKey.html#from_der!/1"},{"type":"function","title":"X509.PublicKey.from_pem/1","doc":"Attempts to parse a public key in PEM format. Expects the input string to include exactly one PEM entry, which must be of type &quot;PUBLIC KEY&quot; or &quot;RSA PUBLIC KEY&quot;. Unwraps a SubjectPublicKeyInfo style container, if present. Returns an :ok tuple in case of success, or an :error tuple in case of failure. Possible error reasons are: :not_found - no PEM entry of a supported PRIVATE KEY type was found :malformed - the entry could not be decoded as a public key","ref":"X509.PublicKey.html#from_pem/1"},{"type":"function","title":"X509.PublicKey.from_pem!/1","doc":"Attempts to parse a public key in PEM format. Raises in case of failure. Expects the input string to include exactly one PEM entry, which must be of type &quot;PUBLIC KEY&quot; or &quot;RSA PUBLIC KEY&quot;. Unwraps a SubjectPublicKeyInfo style container, if present.","ref":"X509.PublicKey.html#from_pem!/1"},{"type":"function","title":"X509.PublicKey.to_der/2","doc":"Converts a public key to DER (binary) format. Options: :wrap - Wrap the private key in a SubjectPublicKeyInfo container (default: true )","ref":"X509.PublicKey.html#to_der/2"},{"type":"function","title":"X509.PublicKey.to_pem/2","doc":"Converts a public key to PEM format. Options: :wrap - Wrap the private key in a SubjectPublicKeyInfo container; for RSA public keys this defaults to true , but for EC public keys this option is ignored and the key is always exported in SubjectPublicKeyInfo format","ref":"X509.PublicKey.html#to_pem/2"},{"type":"function","title":"X509.PublicKey.unwrap/1","doc":"Extracts a public key from a SubjectPublicKeyInfo style container. Supports the same container structures as wrap/2 .","ref":"X509.PublicKey.html#unwrap/1"},{"type":"function","title":"X509.PublicKey.wrap/2","doc":"Wraps a public key in a SubjectPublicKeyInfo (or similar) container. The following container types are supported: :SubjectPublicKeyInfo - standard X.509 structure for storing public keys (default) :OTPSubjectPublicKeyInfo - Erlang/OTP record variant of :SubjectPublicKeyInfo , for use in the :OTPCertificate record :CertificationRequestInfo_subjectPKInfo - for use in a PKCS#10 CertificationRequest (CSR)","ref":"X509.PublicKey.html#wrap/2"},{"type":"type","title":"X509.PublicKey.spki/0","doc":"SubjectPublicKeyInfo container","ref":"X509.PublicKey.html#t:spki/0"},{"type":"type","title":"X509.PublicKey.t/0","doc":"RSA or EC public key","ref":"X509.PublicKey.html#t:t/0"},{"type":"module","title":"X509.RDNSequence","doc":"Convenience functions for creating :rdnSequence tuples, as defined in Erlang's :public_key module as the issuer_name() type, and representing the X.509 RDNSequence type. RDNSequences are primarily used for the Subject and Issuer fields of certificates, as well as the Subject field of CSRs. Note that this module implements a commonly used subset of RDNSequence values. It supports only a single attribute type/value pair for each element in the sequence, and it implements the attribute types specified in RFC5280, section 4.1.2.4, with a few extensions from LDAP: countryName (C) organizationName (O) organizationalUnitName (OU) dnQualifier stateOrProvinceName (ST) commonName (CN) serialNumber localityName (L) title name surname (SN) givenName (GN) initials pseudonym generationQualifier domainComponent (DC) emailAddress (E) This module encodes values as UTF8String where possible, or else PrintableString/IA5String where required.","ref":"X509.RDNSequence.html"},{"type":"function","title":"X509.RDNSequence.get_attr/2","doc":"Extracts the values for the specified attributes from a :rdnSequence tuple. The attribute type may be specified as an attribute name (long or short form, as a string, or long from as an atom) or an OID tuple. Refer to the documentation at the top of this module for a list of supported attributes. Since an attribute may appear more than once in an RDN sequence the result is a list of values. Examples: iex&gt; X509.RDNSequence . new ( &quot;/C=US/CN=Bob&quot; ) |&gt; X509.RDNSequence . get_attr ( :countryName ) [ &quot;US&quot; ] iex&gt; X509.RDNSequence . new ( &quot;/C=US/CN=Bob&quot; ) |&gt; X509.RDNSequence . get_attr ( &quot;commonName&quot; ) [ &quot;Bob&quot; ] iex&gt; X509.RDNSequence . new ( &quot;C=CN, givenName=麗&quot; ) |&gt; X509.RDNSequence . get_attr ( &quot;GN&quot; ) [ &quot;麗&quot; ]","ref":"X509.RDNSequence.html#get_attr/2"},{"type":"function","title":"X509.RDNSequence.new/2","doc":"Creates a new :rdnSequence tuple. The value can be specified in one of the following formats: A string specifying the attributes in hierarchical format, e.g. &quot;/C=US/ST=NT/L=Springfield/O=ACME Inc.&quot; A string specifying a comma-separated list of attributes, e.g. &quot;C=US, ST=NT, L=Springfield, O=ACME Inc.&quot; An RDN attribute list (see type documentation) Note that the string parsers for the first two formats do not (currently) recognize escape characters: separator characters ('/' and ',', respectively) are not allowed in attribute values. The optional second parameter can be used to select the output format: :plain - for use in :Certificate and :CertificationRequest records (default) :otp - for use in :OTPCertificate records (see X509.Certificate ) Raises an error when the given value cannot be parsed, contains unsupported attribute types, when attribute values exceed the maximum length ('upper bound' in the RFC) or when values cannot be coerced into the expected ASN.1 type. Examples: iex&gt; X509.RDNSequence . new ( &quot;/C=US/CN=Bob&quot; ) { :rdnSequence , [ [ { :AttributeTypeAndValue , { 2 , 5 , 4 , 6 } , &lt;&lt; 19 , 2 , 85 , 83 &gt;&gt; } ] , [ { :AttributeTypeAndValue , { 2 , 5 , 4 , 3 } , &lt;&lt; 12 , 3 , 66 , 111 , 98 &gt;&gt; } ] ] } iex&gt; X509.RDNSequence . new ( &quot;C=CN, givenName=麗&quot; ) { :rdnSequence , [ [ { :AttributeTypeAndValue , { 2 , 5 , 4 , 6 } , &lt;&lt; 19 , 2 , 67 , 78 &gt;&gt; } ] , [ { :AttributeTypeAndValue , { 2 , 5 , 4 , 42 } , &lt;&lt; 12 , 3 , 233 , 186 , 151 &gt;&gt; } ] ] } iex&gt; X509.RDNSequence . new ( commonName : &quot;Elixir&quot; ) { :rdnSequence , [ [ { :AttributeTypeAndValue , { 2 , 5 , 4 , 3 } , &lt;&lt; 12 , 6 , 69 , 108 , 105 , 120 , 105 , 114 &gt;&gt; } ] ] } iex&gt; X509.RDNSequence . new ( language : &quot;Elixir&quot; ) ** (FunctionClauseError) no function clause matching in X509.RDNSequence.new_attr/1 iex&gt; X509.RDNSequence . new ( &quot;C=!!&quot; ) ** (ArgumentError) unsupported character(s) in `PrintableString` attribute","ref":"X509.RDNSequence.html#new/2"},{"type":"function","title":"X509.RDNSequence.to_string/1","doc":"Converts an :rdnSequence tuple to a human readable string, in hierarchical format. Examples: iex&gt; X509.RDNSequence . new ( &quot;C=CN, givenName=麗&quot; ) |&gt; X509.RDNSequence . to_string &quot;/C=CN/GN=麗&quot;","ref":"X509.RDNSequence.html#to_string/1"},{"type":"type","title":"X509.RDNSequence.attr/0","doc":"RDN type/value pair. The first element must be a string (short or long form) or atom (long form) matching one of the supported attribute types. The second element is the associated string value, which will be encoded as appropriate for the attribute type. Alternatively, the attribute_type can be specified as an OID, in which case the value is passed to Erlang's :public_key module as-is. Examples of acceptable values include 'character list' and {:utf8String, &quot;string&quot;} .","ref":"X509.RDNSequence.html#t:attr/0"},{"type":"type","title":"X509.RDNSequence.attr_list/0","doc":"List of RDN type/value pairs","ref":"X509.RDNSequence.html#t:attr_list/0"},{"type":"type","title":"X509.RDNSequence.t/0","doc":"RDN sequence for use in OTP certificate and CSR records","ref":"X509.RDNSequence.html#t:t/0"},{"type":"module","title":"X509.Test.CRLServer","doc":"Simple CRL responder for use in test suites.","ref":"X509.Test.CRLServer.html"},{"type":"function","title":"X509.Test.CRLServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"X509.Test.CRLServer.html#child_spec/1"},{"type":"function","title":"X509.Test.CRLServer.get_port/1","doc":"Returns the TCP port number on which the specified X509.Test.Server instance is listening.","ref":"X509.Test.CRLServer.html#get_port/1"},{"type":"function","title":"X509.Test.CRLServer.put_crl/3","doc":"Adds or updates the CRL at the given path.","ref":"X509.Test.CRLServer.html#put_crl/3"},{"type":"function","title":"X509.Test.CRLServer.start_link/1","doc":"Starts a CRL responder. Options: :port - the TCP port to listen on; defaults to 0, meaning an ephemeral port is selected by the operating system, which may be retrieved using get_port/1","ref":"X509.Test.CRLServer.html#start_link/1"},{"type":"module","title":"X509.Test.Server","doc":"Simple TLS server for hosting X509.Test.Suite scenarios.","ref":"X509.Test.Server.html"},{"type":"function","title":"X509.Test.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"X509.Test.Server.html#child_spec/1"},{"type":"function","title":"X509.Test.Server.get_port/1","doc":"Returns the TCP port number on which the specified X509.Test.Server instance is listening.","ref":"X509.Test.Server.html#get_port/1"},{"type":"function","title":"X509.Test.Server.log_opts/0","doc":"","ref":"X509.Test.Server.html#log_opts/0"},{"type":"function","title":"X509.Test.Server.start_link/1","doc":"Starts a test server for the given test suite. Options: :port - the TCP port to listen on; defaults to 0, meaning an ephemeral port is selected by the operating system, which may be retrieved using get_port/1 :response - the data to send back to clients when a successful connection is established (default: &quot;OK&quot;)","ref":"X509.Test.Server.html#start_link/1"},{"type":"module","title":"X509.Test.Suite","doc":"This module may be used to generate a suite of certificates for client or server testing, and offers an sni_fun hook for setting up a test scenario based on the requested hostname. Test scenarios: valid - presenting a valid server certificate valid-missing-chain - presenting a valid server certificate, but configured without the required intermediate CA; should be rejected unless peer verification is disabled or the intermediate CA is trusted by the client valid-expired-chain - presenting a valid server certificate, but configured with an expired intermediate CA; should be rejected unless peer verification is disabled valid-revoked-chain - presenting a valid server certificate, but configured with a revoked intermediate CA; should be rejected unless peer verification is disabled valid-wrong-key - presenting a valid server certificate, but configured with the wrong private key; should always be rejected valid-wrong-host - presenting a valid server certificate with a SAN hostname that does not match; should be rejected unless peer verification is disabled valid-cross-signed - presenting a valid server certificate, cross-signed by an alternative root CA, and with a certificate chain that resolves to both the standard root CA and the cross-signing root CA valid.wildcard - presenting a valid wildcard server certificate wildcard - presenting a valid wildcard server certificate, but without a SAN hostname for the bare domain; should be rejected unless peer verification is disabled invalid.subdomain.wildcard - presenting a valid wildcard server certificate, but accessed using an invalid nested subdomain; should be rejected unless peer verification is disabled expired - presenting an expired server certificate; should be rejected unless peer verification is disabled revoked - presenting a revoked server certificate; should be rejected unless peer verification is disabled selfsigned - presenting a self-signed server certificate; should normally be rejected by a client unless server certificate verification is disabled or the client is configured to explicitly allow the specific certificate ('pinning') selfsigned-wrong-key - presenting a self-signed server certificate, but configured with the wrong private key; should always be rejected selfsigned-wrong-host - presenting a self-signed server certificate with a SAN hostname that does not match; should be rejected unless peer verification is disabled client-cert - requires that the client present a valid certificate","ref":"X509.Test.Suite.html"},{"type":"function","title":"X509.Test.Suite.new/1","doc":"Builds and returns a new test suite. Options: :domain - the test domain to use; any subdomain for the given domain needs to resolve to the IP address where the test server will be hosted, e.g. 127.0.0.1 or ::1; the default value is 'localtest.me', which requires Internet access during test execution :crl_server - the base URL for a CRL server that may be used as a CRL DP; if none is specified, no CRL DPs are included in the generated certificates, and revocation scenarios are not supported :key_type - the type of private keys to generate; may be set to {:rsa, bits} to select RSA keys of the given length, or {:ec, curve} to select ECC keys based on the given curve (default: {:rsa, 1024} )","ref":"X509.Test.Suite.html#new/1"},{"type":"function","title":"X509.Test.Suite.sni_fun/1","doc":"Returns a suitable SNI (Server Name Indication) handler function for the given test suite. May be used to configure custom servers to act as a test suite endpoint. In addition to setting the sni_fun parameter to the return value of this function, the reuse_sessions parameter must be set to false . This ensures that a new handshake is performed on each connection.","ref":"X509.Test.Suite.html#sni_fun/1"},{"type":"type","title":"X509.Test.Suite.t/0","doc":"","ref":"X509.Test.Suite.html#t:t/0"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - v0.8.8 (2023-08-30)","doc":"Fixes Avoid Logger.warn deprecation warning on recent Elixir versions","ref":"changelog.html#v0-8-8-2023-08-30"},{"type":"extras","title":"Changelog - v0.8.7 (2023-05-31)","doc":"Fixes Compatibility with Elixir 1.15","ref":"changelog.html#v0-8-7-2023-05-31"},{"type":"extras","title":"Changelog - v0.8.6 (2023-04-04)","doc":"Fixes Compatibility with Erlang/OTP 25.3","ref":"changelog.html#v0-8-6-2023-04-04"},{"type":"extras","title":"Changelog - v0.8.5 (2022-05-25)","doc":"Fixes [X509.Test.Server] Use :ssl.handshake/3 if available","ref":"changelog.html#v0-8-5-2022-05-25"},{"type":"extras","title":"Changelog - v0.8.4 (2022-03-01)","doc":"Fixes [X509.RDNSequence] Fix handling of surname attribute","ref":"changelog.html#v0-8-4-2022-03-01"},{"type":"extras","title":"Changelog - v0.8.3 (2021-06-07)","doc":"Enhancements [X509.PublicKey] Support 'engine' reference for private keys in derive/1 [X509.CSR] Support 'engine' reference for private keys in new/2,3 [X509.CSR] Add :public_key option for new/3","ref":"changelog.html#v0-8-3-2021-06-07"},{"type":"extras","title":"Changelog - v0.8.2 (2020-11-05)","doc":"Fixes Support for Elixir v1.11","ref":"changelog.html#v0-8-2-2020-11-05"},{"type":"extras","title":"Changelog - v0.8.1 (2020-02-29)","doc":"Fixes [X509.Certificate] Support both 'plain' and 'otp' rdnSequence records [X509.CSR] Support both 'plain' and 'otp' rdnSequence records","ref":"changelog.html#v0-8-1-2020-02-29"},{"type":"extras","title":"Changelog - v0.8.0 (2019-12-09)","doc":"Enhancements [X509.CSR] Add support for extension requests","ref":"changelog.html#v0-8-0-2019-12-09"},{"type":"extras","title":"Changelog - v0.7.0 (2019-07-15)","doc":"Enhancements [X509.Certificate.Template] Add OCSP responder template [X509.Certificate.Extension] Add support for Authority Information Access and OCSP Nocheck extensions Fixes [X509.RDNSequence] Handle teletexString encoding (7-bit only, for now) [X509.PrivateKey] Documentation fixes","ref":"changelog.html#v0-7-0-2019-07-15"},{"type":"extras","title":"Changelog - v0.6.0 (2019-06-18)","doc":"Enhancements [X509.PrivateKey] Allow encryption of PEM output [X509.Test.Suite] Include 'localhost' in all certifictes [X509.Test.Suite] Generate client certificate and associated key [X509.Test.Server] Add 'client-cert' endpoint for testing with client certificate [ x509.gen.suite Mix task] Add --force option [ x509.gen.suite Mix task] Add --password option [ x509.gen.suite Mix task] Generate 'ca_and_chain.pem' file [ x509.gen.selfsigned Mix task] Add --force option","ref":"changelog.html#v0-6-0-2019-06-18"},{"type":"extras","title":"Changelog - v0.5.4 (2019-04-15)","doc":"Enhancements [X509.RDNSequence] Relax length restriction on countryName attribute","ref":"changelog.html#v0-5-4-2019-04-15"},{"type":"extras","title":"Changelog - v0.5.3 (2019-03-14)","doc":"Fixes [X509.RDNSequence] Support more attribute types in to_string/1","ref":"changelog.html#v0-5-3-2019-03-14"},{"type":"extras","title":"Changelog - v0.5.2 (2019-02-21)","doc":"Enhancements [X509.Certificate] Add version/1 , subject/2 and issuer/2 [X509.RDNSequence] Add get_attr/2","ref":"changelog.html#v0-5-2-2019-02-21"},{"type":"extras","title":"Changelog - v0.5.1 (2019-01-03)","doc":"Fixes [X509.Certificate.Validity] The record type returned for GeneralizedTime, used for dates from 2050 forward, was not recognized by OTP, causing certificate creation and encoding to fail (#24)","ref":"changelog.html#v0-5-1-2019-01-03"},{"type":"extras","title":"Changelog - v0.5.0 (2018-11-27)","doc":"Enhancements [X509.CRL] New module for generating and parsing Certificate Revocation Lists (CRLs) [X509.CRL.Entry] New module: CRL entries [X509.CRL.Extension] New module: CRL extensions [X509.Certificate.Extension] Add support for the CRL Distribution Point extension [X509.Test.Suite] New module for generating test suites for TLS client testing [X509.Test.Server] New module: simple server for hosting test suites Add x509.gen.suite Mix task Add x509.test_server Mix task Fixes [X509.Certificate.Validity] The days_from_now/2 function used to calculate the not_after timestamp relative to the not_before value (including the backdate_seconds shift); it is now set relative to the current time","ref":"changelog.html#v0-5-0-2018-11-27"},{"type":"extras","title":"Changelog - v0.4.0 (2018-10-19)","doc":"Breaking changes All from_der and from_pem functions now return an :error tuple on failure instead of nil , and wrap their result in a :ok tuple in case of success. The only exception is the from_pem function in X509, which returns a (possibly empty) list. [X509] Removed to_der/1 , to_pem/1 and from_der/2 [X509.Certificate] Changed the return values of from_der/1 and from_pem/1,2 , as described above Enhancements Add x509.gen.selfsigned Mix task The various from_pem and from_pem! functions are now more lenient: they scan for the first PEM entry of an appropriate type instead of requiring that it be the only entry [X509.Certificate] Add serial/1 to extract a certificate's serial number [X509.Certificate.Template] The length of randomly generated serial numbers can now be specified using a {:random, n} tuple in the :serial field, where n is the length in bytes; the default is {:random, 8} , equivalent to the previous default Fixes [X509.Certificate] Fixed the typespec for second parameter of from_der!/2 , from_der/2 , from_pem!/2 and from_pem/2 [X509.Certificate] Extract the correct RDN from issuer certificate (#13) [X509.Certificate.Extensions] subject_key_identifier/1 returned an AKI record rather than SKI record for ECC keys (#10) [X509.PublicKey] Documentation: corrected the default value for the wrap option for RSA keys in to_der/1 and to_pem/1","ref":"changelog.html#v0-4-0-2018-10-19"},{"type":"extras","title":"Changelog - v0.3.0 (2018-09-22)","doc":"This release paves the way for some changes in the way PEM and DER decoding works. Eventually there will be six functions in each module, as implemented in X509.CSR in this version. The generic functions in the X509 module will eventually be removed, with the exception of the X509.from_pem/2 function, which returns a (possibly filtered) list of entities found in the PEM string. In the next version, all from_der and from_pem functions (except for the one in X509 ) will return :ok / :error tuples, so please update existing code to use the new from_der! and from_pem! functions instead: their return value on success will always be just the module's primary record type. Breaking changes [X509.Certificate] from_der/2 and from_pem/2 now return nil in case of failure, for consistency with the current behaviour of other modules; use the new from_der!/2 and from_pem!/2 to get the old behaviour of raising an exception Enhancements [X509.Certificate] Add from_der!/2 and from_pem!/2 [X509.CSR] Add to_der/1 , to_pem/1 , from_der!/1 , from_der/1 , from_pem!/1 and from_pem/1 [X509.PrivateKey] Add from_der!/2 and from_pem!/2 [X509.PublicKey] Add from_der!/2 and from_pem!/2 Support Elixir v1.7 and ExDoc v0.19 Deprecations The to_der , to_pem and from_der functions in the X509 top-level module have been deprecated. Please use their entity-specific functions in the appropriate module instead. The deprecated functions will be removed in an upcoming release, prior to v1.0.","ref":"changelog.html#v0-3-0-2018-09-22"},{"type":"extras","title":"Changelog - v0.2.0 (2018-07-24)","doc":"Breaking changes [X509.Certificate] Primary type has been changed from :Certificate to :OTPCertificate ; the new/[4,5] and self_signed/[2,3] functions now return an :OTPCertificate record Enhancements [X509] to_der and to_pem now delegate now support :OTPCertificate records, by delegating to X509.Certificate [X509.Certificate] Added certificate-specific implementations of to_der , to_pem , from_der and from_pem","ref":"changelog.html#v0-2-0-2018-07-24"},{"type":"extras","title":"Changelog - v0.1.0 (2018-07-02)","doc":"First public release","ref":"changelog.html#v0-1-0-2018-07-02"},{"type":"extras","title":"X509","doc":"Elixir package for working with X.509 certificates, Certificate Signing Requests (CSRs), Certificate Revocation Lists (CRLs) and RSA/ECC key pairs. Requires Erlang/OTP 20.1 or later. Development and public release of this package were made possible by Bluecode .","ref":"readme.html"},{"type":"extras","title":"X509 - Usage","doc":"As a Certificate Authority (CA) Generate a self-signed CA certificate and private key, using the root_ca template: iex&gt; ca_key = X509.PrivateKey . new_ec ( :secp256r1 ) { :ECPrivateKey , ... } iex&gt; ca = X509.Certificate . self_signed ( ca_key , ...&gt; &quot;/C=US/ST=CA/L=San Francisco/O=Acme/CN=ECDSA Root CA&quot; , ...&gt; template : :root_ca ...&gt; ) { :OTPCertificate , ... } Use the CA certificate to issue a server certificate, using the default server template and the given SAN hostnames: iex&gt; my_key = X509.PrivateKey . new_ec ( :secp256r1 ) { :ECPrivateKey , ... } iex&gt; my_cert = my_key |&gt; ...&gt; X509.PublicKey . derive ( ) |&gt; ...&gt; X509.Certificate . new ( ...&gt; &quot;/C=US/ST=CA/L=San Francisco/O=Acme/CN=Sample&quot; , ...&gt; ca , ca_key , ...&gt; extensions : [ ...&gt; subject_alt_name : X509.Certificate.Extension . subject_alt_name ( [ &quot;example.org&quot; , &quot;www.example.org&quot; ] ) ...&gt; ] ...&gt; ) { :OTPCertificate , ... } Or sign a certificate based on an incoming CSR: iex&gt; csr = X509.CSR . from_pem! ( pem_string ) { :CertificationRequest , ... } iex&gt; subject = X509.CSR . subject ( csr ) { :rdnSequence , ... } iex&gt; my_cert = csr |&gt; ...&gt; X509.CSR . public_key ( ) |&gt; ...&gt; X509.Certificate . new ( ...&gt; subject , ...&gt; ca , ca_key , ...&gt; extensions : [ ...&gt; subject_alt_name : X509.Certificate.Extension . subject_alt_name ( [ &quot;example.org&quot; , &quot;www.example.org&quot; ] ) ...&gt; ] ...&gt; ) With :public_key for encryption/signing Please refer to the documentation for the X509.PrivateKey module for examples showing asymmetrical encryption and decryption, as well as message signing and verification, with Erlang/OTP's :public_key APIs. For TLS client/server testing The x509.gen.selfsigned Mix task generates a self-signed certificate for use with a TLS server in development or testing. The X509.Test.Suite and X509.Test.Server modules may be used to create test cases for TLS clients. The server_test.exs file can serve as a template: update the request/2 function to invoke of the TLS client under test, make sure it returns the expected response format, and update the test server's canned response in the test module's setup if necessary. You may want to include the X509 package only in the 'dev' and/or 'test' environments for this use-case, by adding an only: ... clause to the dependency definition in your Mix file.","ref":"readme.html#usage"},{"type":"extras","title":"X509 - Installation","doc":"Add x509 to your list of dependencies in mix.exs : def deps do [ { :x509 , &quot;~&gt; 0.8&quot; } ] end Documentation can be found at https://hexdocs.pm/x509 .","ref":"readme.html#installation"},{"type":"extras","title":"X509 - License","doc":"Copyright (c) 2019, Bram Verburg All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"readme.html#license"}]